/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.Indexes;
import de.ship.db.Keys;
import de.ship.db.enums.EnumLogicvalidreason;
import de.ship.db.tables.TCoreElementHierarchy.TCoreElementHierarchyPath;
import de.ship.db.tables.TCoreLogiclist.TCoreLogiclistPath;
import de.ship.db.tables.TCoreLogicorgrp.TCoreLogicorgrpPath;
import de.ship.db.tables.TCoreLogicsubst.TCoreLogicsubstPath;
import de.ship.db.tables.TCoreLogictype.TCoreLogictypePath;
import de.ship.db.tables.records.TCoreLogicRecord;

import java.time.LocalDateTime;
import java.util.Arrays;
import java.util.Collection;
import java.util.List;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.ForeignKey;
import org.jooq.Identity;
import org.jooq.Index;
import org.jooq.InverseForeignKey;
import org.jooq.Name;
import org.jooq.Path;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.Record;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.UniqueKey;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class TCoreLogic extends TableImpl<TCoreLogicRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.t_core_logic</code>
     */
    public static final TCoreLogic T_CORE_LOGIC = new TCoreLogic();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<TCoreLogicRecord> getRecordType() {
        return TCoreLogicRecord.class;
    }

    /**
     * The column <code>common_dd.t_core_logic.pk_core_logic</code>.
     */
    public final TableField<TCoreLogicRecord, Integer> PK_CORE_LOGIC = createField(DSL.name("pk_core_logic"), SQLDataType.INTEGER.nullable(false).identity(true), this, "");

    /**
     * The column <code>common_dd.t_core_logic.fk_logictype</code>.
     */
    public final TableField<TCoreLogicRecord, Integer> FK_LOGICTYPE = createField(DSL.name("fk_logictype"), SQLDataType.INTEGER.nullable(false), this, "");

    /**
     * The column <code>common_dd.t_core_logic.fk_orgrp</code>.
     */
    public final TableField<TCoreLogicRecord, Integer> FK_ORGRP = createField(DSL.name("fk_orgrp"), SQLDataType.INTEGER.nullable(false), this, "");

    /**
     * The column <code>common_dd.t_core_logic.fk_variable</code>.
     */
    public final TableField<TCoreLogicRecord, Integer> FK_VARIABLE = createField(DSL.name("fk_variable"), SQLDataType.INTEGER.nullable(false), this, "");

    /**
     * The column <code>common_dd.t_core_logic.lastchange</code>.
     */
    public final TableField<TCoreLogicRecord, LocalDateTime> LASTCHANGE = createField(DSL.name("lastchange"), SQLDataType.LOCALDATETIME(6).defaultValue(DSL.field(DSL.raw("now()"), SQLDataType.LOCALDATETIME)), this, "");

    /**
     * The column <code>common_dd.t_core_logic.valid_from</code>.
     */
    public final TableField<TCoreLogicRecord, LocalDateTime> VALID_FROM = createField(DSL.name("valid_from"), SQLDataType.LOCALDATETIME(6), this, "");

    /**
     * The column <code>common_dd.t_core_logic.valid_until</code>.
     */
    public final TableField<TCoreLogicRecord, LocalDateTime> VALID_UNTIL = createField(DSL.name("valid_until"), SQLDataType.LOCALDATETIME(6), this, "");

    /**
     * The column <code>common_dd.t_core_logic.valid_comment</code>.
     */
    public final TableField<TCoreLogicRecord, String> VALID_COMMENT = createField(DSL.name("valid_comment"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.t_core_logic.valid_reason</code>.
     */
    public final TableField<TCoreLogicRecord, EnumLogicvalidreason> VALID_REASON = createField(DSL.name("valid_reason"), SQLDataType.VARCHAR.asEnumDataType(EnumLogicvalidreason.class), this, "");

    private TCoreLogic(Name alias, Table<TCoreLogicRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private TCoreLogic(Name alias, Table<TCoreLogicRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.table(), where);
    }

    /**
     * Create an aliased <code>common_dd.t_core_logic</code> table reference
     */
    public TCoreLogic(String alias) {
        this(DSL.name(alias), T_CORE_LOGIC);
    }

    /**
     * Create an aliased <code>common_dd.t_core_logic</code> table reference
     */
    public TCoreLogic(Name alias) {
        this(alias, T_CORE_LOGIC);
    }

    /**
     * Create a <code>common_dd.t_core_logic</code> table reference
     */
    public TCoreLogic() {
        this(DSL.name("t_core_logic"), null);
    }

    public <O extends Record> TCoreLogic(Table<O> path, ForeignKey<O, TCoreLogicRecord> childPath, InverseForeignKey<O, TCoreLogicRecord> parentPath) {
        super(path, childPath, parentPath, T_CORE_LOGIC);
    }

    /**
     * A subtype implementing {@link Path} for simplified path-based joins.
     */
    public static class TCoreLogicPath extends TCoreLogic implements Path<TCoreLogicRecord> {

        private static final long serialVersionUID = 1L;
        public <O extends Record> TCoreLogicPath(Table<O> path, ForeignKey<O, TCoreLogicRecord> childPath, InverseForeignKey<O, TCoreLogicRecord> parentPath) {
            super(path, childPath, parentPath);
        }
        private TCoreLogicPath(Name alias, Table<TCoreLogicRecord> aliased) {
            super(alias, aliased);
        }

        @Override
        public TCoreLogicPath as(String alias) {
            return new TCoreLogicPath(DSL.name(alias), this);
        }

        @Override
        public TCoreLogicPath as(Name alias) {
            return new TCoreLogicPath(alias, this);
        }

        @Override
        public TCoreLogicPath as(Table<?> alias) {
            return new TCoreLogicPath(alias.getQualifiedName(), this);
        }
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public List<Index> getIndexes() {
        return Arrays.asList(Indexes.IDX_CORE_LOGIC_FK_LOGICTYPE, Indexes.IDX_CORE_LOGIC_FK_ORGRP, Indexes.IDX_CORE_LOGIC_FK_VARIABLE);
    }

    @Override
    public Identity<TCoreLogicRecord, Integer> getIdentity() {
        return (Identity<TCoreLogicRecord, Integer>) super.getIdentity();
    }

    @Override
    public UniqueKey<TCoreLogicRecord> getPrimaryKey() {
        return Keys.PK_CORE_LOGIC;
    }

    @Override
    public List<UniqueKey<TCoreLogicRecord>> getUniqueKeys() {
        return Arrays.asList(Keys.UK_LOGIC);
    }

    @Override
    public List<ForeignKey<TCoreLogicRecord, ?>> getReferences() {
        return Arrays.asList(Keys.T_CORE_LOGIC__FK_LOGICTYPE, Keys.T_CORE_LOGIC__FK_LOGIC_ORGRP, Keys.T_CORE_LOGIC__FK_LOGIC_ELEMENT);
    }

    private transient TCoreLogictypePath _tCoreLogictype;

    /**
     * Get the implicit join path to the <code>common_dd.t_core_logictype</code>
     * table.
     */
    public TCoreLogictypePath tCoreLogictype() {
        if (_tCoreLogictype == null)
            _tCoreLogictype = new TCoreLogictypePath(this, Keys.T_CORE_LOGIC__FK_LOGICTYPE, null);

        return _tCoreLogictype;
    }

    private transient TCoreLogicorgrpPath _tCoreLogicorgrp;

    /**
     * Get the implicit join path to the
     * <code>common_dd.t_core_logicorgrp</code> table.
     */
    public TCoreLogicorgrpPath tCoreLogicorgrp() {
        if (_tCoreLogicorgrp == null)
            _tCoreLogicorgrp = new TCoreLogicorgrpPath(this, Keys.T_CORE_LOGIC__FK_LOGIC_ORGRP, null);

        return _tCoreLogicorgrp;
    }

    private transient TCoreElementHierarchyPath _tCoreElementHierarchy;

    /**
     * Get the implicit join path to the
     * <code>common_dd.t_core_element_hierarchy</code> table.
     */
    public TCoreElementHierarchyPath tCoreElementHierarchy() {
        if (_tCoreElementHierarchy == null)
            _tCoreElementHierarchy = new TCoreElementHierarchyPath(this, Keys.T_CORE_LOGIC__FK_LOGIC_ELEMENT, null);

        return _tCoreElementHierarchy;
    }

    private transient TCoreLogiclistPath _tCoreLogiclist;

    /**
     * Get the implicit to-many join path to the
     * <code>common_dd.t_core_logiclist</code> table
     */
    public TCoreLogiclistPath tCoreLogiclist() {
        if (_tCoreLogiclist == null)
            _tCoreLogiclist = new TCoreLogiclistPath(this, null, Keys.T_CORE_LOGICLIST__FK_CORE_LOGICLIST_LOGIC.getInverseKey());

        return _tCoreLogiclist;
    }

    private transient TCoreLogicsubstPath _tCoreLogicsubst;

    /**
     * Get the implicit to-many join path to the
     * <code>common_dd.t_core_logicsubst</code> table
     */
    public TCoreLogicsubstPath tCoreLogicsubst() {
        if (_tCoreLogicsubst == null)
            _tCoreLogicsubst = new TCoreLogicsubstPath(this, null, Keys.T_CORE_LOGICSUBST__FK_CORE_LOGICSUBST_LOGIC.getInverseKey());

        return _tCoreLogicsubst;
    }

    @Override
    public TCoreLogic as(String alias) {
        return new TCoreLogic(DSL.name(alias), this);
    }

    @Override
    public TCoreLogic as(Name alias) {
        return new TCoreLogic(alias, this);
    }

    @Override
    public TCoreLogic as(Table<?> alias) {
        return new TCoreLogic(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public TCoreLogic rename(String name) {
        return new TCoreLogic(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public TCoreLogic rename(Name name) {
        return new TCoreLogic(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public TCoreLogic rename(Table<?> name) {
        return new TCoreLogic(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreLogic where(Condition condition) {
        return new TCoreLogic(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreLogic where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreLogic where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreLogic where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreLogic where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreLogic where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreLogic where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreLogic where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreLogic whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreLogic whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
